"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var THREE = _interopRequireWildcard(require("three"));

var _computeBufferTileGeometry = _interopRequireDefault(require("./Prefab/computeBufferTileGeometry"));

function defaultBuffers(params) {
  params.buildIndexAndWGS84 = true;
  params.center = params.builder.center(params.extent).clone();
  var buffers = (0, _computeBufferTileGeometry["default"])(params);
  buffers.index = new THREE.BufferAttribute(buffers.index, 1);
  buffers.uv.wgs84 = new THREE.BufferAttribute(buffers.uv.wgs84, 2);
  buffers.position = new THREE.BufferAttribute(buffers.position, 3);
  buffers.normal = new THREE.BufferAttribute(buffers.normal, 3);
  buffers.uv.pm = new THREE.BufferAttribute(buffers.uv.pm, 1);
  return buffers;
}

var TileGeometry =
/*#__PURE__*/
function (_THREE$BufferGeometry) {
  (0, _inherits2["default"])(TileGeometry, _THREE$BufferGeometry);

  function TileGeometry(params) {
    var _this;

    var buffers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultBuffers(params);
    (0, _classCallCheck2["default"])(this, TileGeometry);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(TileGeometry).call(this));
    _this.center = params.center;
    _this.extent = params.extent;

    _this.setIndex(buffers.index);

    _this.addAttribute('uv_wgs84', buffers.uv.wgs84);

    _this.addAttribute('position', buffers.position);

    _this.addAttribute('normal', buffers.normal);

    _this.addAttribute('uv_pm', buffers.uv.pm);

    _this.computeBoundingBox();

    _this.OBB = {};
    return _this;
  }

  return TileGeometry;
}(THREE.BufferGeometry);

var _default = TileGeometry;
exports["default"] = _default;